from ....utils import register_action
from nose.tools import assert_is_not_none, assert_in, assert_equal
from unittest import TestCase


class RegistryTest(TestCase):

    def test_root(self):

        class Worker:
            @register_action('test')
            def handle_test(self):
                pass

        actions = getattr(Worker, '__actions__')
        assert_is_not_none(actions)
        assert_in('test', actions)
        assert_equal(1, len(actions))

    def test_child(self):

        class Parent:
            pass

        class Child(Parent):
            @register_action('test')
            def handle_test(self):
                pass

        actions = getattr(Child, '__actions__')
        assert_is_not_none(actions)
        assert_in('test', actions)
        assert_equal(1, len(actions))
        assert_equal(Child.handle_test, actions['test'])
